package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.ListTanggalCuti;
import com.jasamedika.medifirst2000.vo.ListTanggalCutiVO;

/**
 * Converter class between Jabatan and JabatanVO
 * 
 * @author salmanoe
 */
@Component
public class ListTanggalCutiConverter implements BaseVoConverter<ListTanggalCutiVO, ListTanggalCuti> {

	@Override
	public ListTanggalCuti transferVOToModel(ListTanggalCutiVO vo, ListTanggalCuti model) {
		if (null == model)
			model = new ListTanggalCuti();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, ListTanggalCuti.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return model;
	}

	@Override
	public List<ListTanggalCutiVO> transferListOfModelToListOfVO(List<ListTanggalCuti> models,
			List<ListTanggalCutiVO> vos) {
		if (null == vos)
			vos = new ArrayList<ListTanggalCutiVO>();

		if (null == models)
			return vos;

		for (ListTanggalCuti listTanggalCuti : models) {
			ListTanggalCutiVO vo = new ListTanggalCutiVO();
			vo = transferModelToVO(listTanggalCuti, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public ListTanggalCutiVO transferModelToVO(ListTanggalCuti model, ListTanggalCutiVO vo) {
		if (null == vo)
			vo = new ListTanggalCutiVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, ListTanggalCutiVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	}

}
